// Code generated by goa v3.12.3, DO NOT EDIT.
//
// login client
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/login/design

package login

import (
	"context"

	goa "goa.design/goa/v3/pkg"
)

// Client is the "login" service client.
type Client struct {
	LoginEndpoint           goa.Endpoint
	LoginInvitationEndpoint goa.Endpoint
	LoginWithVCEndpoint     goa.Endpoint
	KeysEndpoint            goa.Endpoint
}

// NewClient initializes a "login" service client given the endpoints.
func NewClient(login, loginInvitation, loginWithVC, keys goa.Endpoint) *Client {
	return &Client{
		LoginEndpoint:           login,
		LoginInvitationEndpoint: loginInvitation,
		LoginWithVCEndpoint:     loginWithVC,
		KeysEndpoint:            keys,
	}
}

// Login calls the "Login" endpoint of the "login" service.
func (c *Client) Login(ctx context.Context, p *LoginRequest) (res *LoginResult, err error) {
	var ires any
	ires, err = c.LoginEndpoint(ctx, p)
	if err != nil {
		return
	}
	return ires.(*LoginResult), nil
}

// LoginInvitation calls the "LoginInvitation" endpoint of the "login" service.
func (c *Client) LoginInvitation(ctx context.Context) (res *LoginInvitationResult, err error) {
	var ires any
	ires, err = c.LoginInvitationEndpoint(ctx, nil)
	if err != nil {
		return
	}
	return ires.(*LoginInvitationResult), nil
}

// LoginWithVC calls the "LoginWithVC" endpoint of the "login" service.
func (c *Client) LoginWithVC(ctx context.Context, p *LoginVCRequest) (res *LoginVCResult, err error) {
	var ires any
	ires, err = c.LoginWithVCEndpoint(ctx, p)
	if err != nil {
		return
	}
	return ires.(*LoginVCResult), nil
}

// Keys calls the "Keys" endpoint of the "login" service.
func (c *Client) Keys(ctx context.Context) (res *KeysResult, err error) {
	var ires any
	ires, err = c.KeysEndpoint(ctx, nil)
	if err != nil {
		return
	}
	return ires.(*KeysResult), nil
}
